/* Autogenerated by ../bin/halcompile on Thu Mar 12 18:31:21 2020 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:carousel:Orient a toolchanger carousel using various encoding schemes\n\n.B loadrt toolchange pockets=\\fIN\\fR[,\\fIN\\fR]\n.B encoding=\\fIssss\\fR[,\\fIsss\\fR]\\fB\n.B num_sense=\\fIN\\fR[,\\fIN\\fR]\n.B bidirectional=\\fIN\\fR[,\\fIN]\n\n.RS 4\n.TP\n\\fBpockets\\fR The number of pockets in each toolchanger.\nUse up to 8 numbers separated by commas to create multiple carousel components.\n.TP\n\\fBencoding\\fR The position encoding.\ngray, binary, index or single. Default = 'gray'\n.TP\n\\fBnum_sense\\fR The number of position sense pins.\nDefault = 4.\n.TP\n\\fBdir\\fR Set to 1 for unidirectional or  2 for bidirectional operation.\nDefault = bidirectional\n.RE");
MODULE_INFO(linuxcnc, "descr:This component is intended to help operate various types of\ncarousel-type toolchangers. \nThe component can be configured to operate with binary or gray-coded position \nfeedback, with an individual sensor for each tool position or with a sensor at each\ntool position and a separate index.\n\nAt the moment it is best-suited to Geneva-mechanism type systems where the\nmotor is either on or off.\nBoth unidirectional and bidirectional systems are supported. \n\nThe number of carousel component instances created depends on the number of\nentries in the 'pockets' modparam. For example\n\n.B loadrt carousel pockets=10,10,8\n\nWould create 3 carousel instances with 10, 10 and 8 pockets. The other \nparameters are optional. If absent then defaults will be used. Any missing\nentry will assume the previous value.\n\nWhen the enable pin is set to true the component will immediately set the \n\"active\" pin to true and then (for a bidirectional instance) calculate the\nshortest path to the requested pocket number. The appropriate motor direction\noutput pin will then be set.\n\nThe component will monitor the carousel position and, when the correct position\nis reached, set the motor-control pins to 0, set \"active\" to 0 and set \"ready\"\nto 1.\n\nIn index mode the behaviour is slightly different the first time that the \"enable\"\npin is set; the carousel will rotate forwards when first enabled until \nboth the index and pulse inputs are true. If there is no pulse line at the\nindex position then a HAL \"or2\" function can be used to allow the index sensor\nto toggle both inputs. Setting \"enable\" low does not halt the homing move, so if\nhoming on first tool change is not needed then the enable pin can be toggled by\nan axis homing pin or a script. \n");
MODULE_INFO(linuxcnc, "pin:pocket-number:s32:0:in:The pocket to move to when the .enable pin goes high:None:None");
MODULE_INFO(linuxcnc, "pin:enable:bit:0:in:Set this pin high to start movement. Setting it low will stop movement:None:None");
MODULE_INFO(linuxcnc, "pin:active:bit:0:out:indicates that the component is active:None:None");
MODULE_INFO(linuxcnc, "pin:ready:bit:0:out:This pin goes high when the carousel is in-position:None:None");
MODULE_INFO(linuxcnc, "pin:sense-#:bit:(32, 'personality'):in:Carousel position feedback pins. In 'index' mode there \nwill be only 2 pins. sense-0 is the index and sense-1 is the pocket sensor.:None:None");
MODULE_INFO(linuxcnc, "pin:motor-fwd:bit:0:out:Indicates the motor should run forwards (bigger numbers):None:None");
MODULE_INFO(linuxcnc, "pin:motor-rev:bit:0:out:Indicates the motor should run reverse.:None:None");
MODULE_INFO(linuxcnc, "pin:current-position:s32:0:out:This pin indicates the current position feedback:None:None");
MODULE_INFO(linuxcnc, "param:state:s32:0:r:Current component state:0:None");
MODULE_INFO(linuxcnc, "param:homing:bit:0:r:Shows that homing is in progress. Only used for index mode:0:None");
MODULE_INFO(linuxcnc, "param:homed:bit:0:r:Shows that homing is complete. Only used in index mode:0:None");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:andy pugh");
MODULE_INFO(linuxcnc, "funct:_:0:");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    int _personality;
    hal_s32_t *pocket_number;
    hal_bit_t *enable;
    hal_bit_t *active;
    hal_bit_t *ready;
    hal_bit_t *sense[32];
    hal_bit_t *motor_fwd;
    hal_bit_t *motor_rev;
    hal_s32_t *current_position;
    hal_s32_t state;
    hal_bit_t homing;
    hal_bit_t homed;
    int inst_sense;

    int inst_dir;

    int inst_pockets;

    int inst_code;

    int old_index;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg, long personality) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_personality = personality;
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    personality = inst->_personality;
    r = hal_pin_s32_newf(HAL_IN, &(inst->pocket_number), comp_id,
        "%s.pocket-number", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->enable), comp_id,
        "%s.enable", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->active), comp_id,
        "%s.active", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->ready), comp_id,
        "%s.ready", prefix);
    if(r != 0) return r;
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->sense[j]), comp_id,
            "%s.sense-%01d", prefix, j);
        if(r != 0) return r;
    }
    r = hal_pin_bit_newf(HAL_OUT, &(inst->motor_fwd), comp_id,
        "%s.motor-fwd", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->motor_rev), comp_id,
        "%s.motor-rev", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->current_position), comp_id,
        "%s.current-position", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RO, &(inst->state), comp_id,
        "%s.state", prefix);
    inst->state = 0;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RO, &(inst->homing), comp_id,
        "%s.homing", prefix);
    inst->homing = 0;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RO, &(inst->homed), comp_id,
        "%s.homed", prefix);
    inst->homed = 0;
    if(r != 0) return r;
    inst->old_index = 0.0;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int get_count(void);
static int personality[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_INT(personality, 16, "personality of each carousel");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    int count = get_count();
    comp_id = hal_init("carousel");
    if(comp_id < 0) return comp_id;
    for(i=0; i<count; i++) {
        char buf[HAL_NAME_LEN + 1];
        rtapi_snprintf(buf, sizeof(buf), "carousel.%d", i);
        r = export(buf, i, personality[i%16]);
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef pocket_number
#define pocket_number (0+*__comp_inst->pocket_number)
#undef enable
#define enable (0+*__comp_inst->enable)
#undef active
#define active (*__comp_inst->active)
#undef ready
#define ready (*__comp_inst->ready)
#undef sense
#define sense(i) (0+*(__comp_inst->sense[i]))
#undef motor_fwd
#define motor_fwd (*__comp_inst->motor_fwd)
#undef motor_rev
#define motor_rev (*__comp_inst->motor_rev)
#undef current_position
#define current_position (*__comp_inst->current_position)
#undef state
#define state (__comp_inst->state)
#undef homing
#define homing (__comp_inst->homing)
#undef homed
#define homed (__comp_inst->homed)
#undef inst_sense
#define inst_sense (__comp_inst->inst_sense)
#undef inst_dir
#define inst_dir (__comp_inst->inst_dir)
#undef inst_pockets
#define inst_pockets (__comp_inst->inst_pockets)
#undef inst_code
#define inst_code (__comp_inst->inst_code)
#undef old_index
#define old_index (__comp_inst->old_index)
#undef personality
#define personality (__comp_inst->_personality)


#line 89 "hal/components/carousel.comp"

int default_pockets = 8;
int default_code = 'G';
int default_dir = 2;
int default_sense = 4;

#define MAX_CHAN 8
static int pockets[MAX_CHAN] = {-1};
RTAPI_MP_ARRAY_INT(pockets, MAX_CHAN, "The number of pockets in each carousel")
static char *encoding[MAX_CHAN];
RTAPI_MP_ARRAY_STRING(encoding, MAX_CHAN, "Position feedback type")
static int dir[MAX_CHAN] = {-1};
RTAPI_MP_ARRAY_INT(dir, MAX_CHAN, 
                    "set to 2 if the carousel is bidirectional")
static int num_sense[MAX_CHAN] = {-1};
RTAPI_MP_ARRAY_INT(num_sense, MAX_CHAN, "The number of sense pins to create")


FUNCTION(_){
    int i;
    int p = 0;
    unsigned int mask;

    switch inst_code{
    case 'G': // Gray Code
        for (i = 0; i < inst_sense ; i++) {
            p += sense(i) << i;
        }
        for(mask = p >> 1 ; mask != 0 ; mask = mask >> 1){
            p ^= mask;
        }
        break;
    case 'B': // Straight Binary
        for (i = 0; i < inst_sense ; i++) {
            p += sense(i) << i;
        }
        break;
    case 'S': // individual sensors
        for (i = inst_sense - 1; sense(i) == 0 && i > 0 ; i--) {}
        p = i;
        break;
    case 'I': // index + position.
        p = current_position;
        if (homed){
            if ( !old_index && sense(1)){
                if (motor_fwd){
                    p += 1;
                    if (p > inst_pockets) p -= inst_pockets;
                }
                if (motor_rev) {
                    p -= 1;
                    if (p < 1) p += inst_pockets;
                }
            }
            old_index = sense(1);
        }
        break;
    }

    current_position = p;

    switch (state){
    case 0: // waiting at start
        if (! enable) return ;
        active = 1;
        if (inst_code == 'I' && ! homed){
            state = 10;
            break;
        }
        state = 1;
        ready = 0;
    case 1: // choose direction
        if (pocket_number < 1 || pocket_number > inst_pockets) {
            state = 0;
            return;
        }
        if (inst_dir == 2){
            if (current_position < pocket_number){
                if (pocket_number - current_position > (inst_pockets / 2)) {
                    motor_fwd = 0;
                    motor_rev = 1;
                } else {
                    motor_fwd = 1;
                    motor_rev = 0;
                }
            } else {
                if (current_position - pocket_number > (inst_pockets / 2)) {
                    motor_fwd = 1;
                    motor_rev = 0;
                } else {
                    motor_fwd = 0;
                    motor_rev = 1;
                }
            }
        } else {
            motor_fwd = 1;
            motor_rev = 0;
        }
        state = 2;
    case 2: // moving
        if ((current_position != pocket_number) && enable) return;
        motor_fwd = 0;
        motor_rev = 0;
        state = 3;
        active = 0;
        if (enable) ready = 1;
    case 3: //waiting for enable to go false
        if (enable) return;
        state = 0;
        break;
    case 10: // start of homing
        homed = 0;
        homing = 1;
        motor_fwd = 1;
        motor_rev = 0;
        state = 11;
    case 11: // waiting for index & pulse
        if  ( (! old_index) && (sense(0) && sense(1)) ){ // index found
            current_position = 1;
            homed = 1;
            homing = 0;
            active = 0;
            state = 0;
        }
        old_index = (sense(0) && sense(1));
        break; // So that we don't see the tool1 pulse twice
    }
}

EXTRA_SETUP(){
    if (pockets[extra_arg] > 0) default_pockets = pockets[extra_arg];
    if (encoding[extra_arg] == NULL) {
        //it's already default_code
    } else if (strncmp(encoding[extra_arg], "binary", 6) == 0) {
        default_code = 'B';
    } else if (strncmp(encoding[extra_arg], "single", 6) == 0) {
        default_code = 'S';
    } else if (strncmp(encoding[extra_arg], "index", 5) == 0) {
        default_code = 'I';
    }

    if (dir[extra_arg] > 0)  default_dir = (dir[extra_arg] > 1)? 2:1;
    
    if (default_code == 'I') {
        default_sense = 2;
    } else if (num_sense[extra_arg] > 0 ) {
        default_sense = num_sense[extra_arg];
    }
    
    inst_pockets = default_pockets;
    inst_code = default_code;
    inst_dir = default_dir;
    inst_sense = default_sense;

    if (inst_code == 'S' && inst_sense < inst_pockets) inst_sense = inst_pockets;
    personality = inst_sense;

    return 0;
}

int get_count(void){
    int i;
    for (i = 0; pockets[i] != 0 && i < MAX_CHAN; i++){}
    if (i == 0) return 1 ;
    return i;
}

static int __comp_get_data_size(void) { return 0; }
