/* Autogenerated by ../bin/halcompile on Thu Mar 12 18:31:21 2020 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:moveoff:Component for Hal-only offsets");
MODULE_INFO(linuxcnc, "descr:\nThe moveoff component is used to offset joint positions using custom Hal\nconnections.  Implementing an offset-while-program-is-paused functionality is\nsupported with appropriate connections for the input pins.  Nine joints are\nsupported.\n\nThe axis offset pin values (offset-in-M) are continuously applied (respecting\nlimits on value, velocity, and acceleration) to the output pins\n(offset-current-M, pos-plusoffset-M, fb-minusoffset-M) when both enabling input\npins (apply-offsets and move-enable) are TRUE.  The two enabling inputs are\nanded internally.   A \\fBwarning\\fR pin is set and a message issued if the\napply-offsets pin is deasserted while offsets are applied.  The warning pin\nremains TRUE until the offsets are removed or the apply-offsets pin is set.\n\nTypically, the move-enable pin is connected to external controls and the\napply-offsets pin is connected to halui.program.is-paused (for offsets only\nwhile paused) or set to TRUE (for continuously applied offsets).\n\nApplied offsets are \\fBautomatically returned\\fR to zero (respecting limits)\nwhen either of the enabling inputs is deactivated.  The zero value\ntolerance is specified by the epsilon input pin value.\n\nWaypoints are recorded when the moveoff componenent is enabled.  Waypoints are\nmanaged with the waypoint-sample-secs and waypoint-threshold pins.  When the\nbacktrack-enable pin is TRUE, the auto-return path follows the recorded\nwaypoints.  When the memory available for waypoints is exhausted, offsets are\nfrozen and the waypoint-limit pin is asserted.  This restriction applies\nregardless of the state of the backtrack-enable pin.  An enabling pin must be\ndeasserted to allow a return to the original (non-offset position).\n\nBacktracking through waypoints results in \\fBslower\\fR movement rates as the\nmoves are point-to-point respecting velocity and acceleration settings.  The\nvelocity and acceleration limit pins can be managed dynamically to control\noffsets at all times.\n\nWhen backtrack-enable is FALSE, the auto-return move is \\fBNOT\\fR\ncoordinated, each axis returns to zero at its own rate.  If a controlled path\nis wanted in this condition, each axis should be manually returned to zero\nbefore deasserting an enabling pin.\n\nThe waypoint-sample-secs, waypoint-threshold, and epsilon pins are evaluated\nonly when the component is idle.\n\nThe offsets-applied output pin is provided to indicate the current state to a\nGUI so that program resumption can be managed.  If the offset(s) are non-zero\nwhen the apply-offsets pin is deasserted (for example when resuming a program\nwhen offsetting during a pause), offsets are returned to zero (respecting\nlimits) and an \\fBError\\fR message is issued.\n\n\\fBCaution:\\fR If offsets are enabled and applied and the machine is turned off\nfor any reason, any \\fBexternal\\fR Hal logic that manages the enabling pins\nand the offset-in-M inputs is responsible for their state when the\nmachine is subsequently turned on again.\n\nThis Hal-only means of offsetting is typically not known to LinuxCNC\nnor available in GUI preview displays.  \\fBNo protection is provided\\fR for\noffset moves that exceed soft limits managed by LinuxCNC.  Since soft limits\nare not honored, an offset move may encounter hard limits (or \\fBCRASH\\fR if\nthere are no limit switches).  Use of the offset-min-M and offset-max-M inputs\nto limit travel is recommended.  Triggering a hard limit will turn off\nthe machine -- see \\fBCaution\\fR above.\n\nThe offset-in-M values may be set with inifile settings, controlled by a GUI,\nor managed by other Hal components and connections.  Fixed values may be\nappropriate in simple cases where the direction and amount of offset is\nwell-defined but a control method is required to deactivate an enabling\npin in order to return offsets to zero.  GUIs may provide means for users to\nset, increment, decrement, and accumulate offset values for each axis and may\nset offset-in-M values to zero before deasserting an enabling pin.\n\nThe default values for accel, vel, min, max, epsilon, waypoint-sample-secs, and\nwaypoint-threshold may not be suitable for any particular application.  This\nHal component is unaware of limits enforced elsewhere by LinuxCNC.\nUsers should test usage in a simulator application and understand all\nhazards \\fBbefore\\fR use on hardware.\n\nThe module personality item sets the number of joints supported (default==3,\nmaximum is 9).\n\nUse of the names= option for naming is \\fBrequired\\fR for compatibility\nwith the gui provided as scripts/moveoff_gui:\n  loadrt moveoff names=\\fBmv\\fR personality=number_of_joints\n\n\\fBman moveoff_gui\\fR for more information\n\n.SH EXAMPLES\nExample simulator configs that demonstrate the moveoff component and a simple gui\n(scripts/moveoff_gui) are located in configs/sim/axis/moveoff. The axis gui is\nused for the demonstrations and the configs can be adapted for other guis like\ntouchy and gscreen.  An example with the touchy gui is provided in\nconfigs/sim/touchy/ngcgui/.\n\n");
MODULE_INFO(linuxcnc, "pin:power_on:bit:0:in:Connect to motion.motion-enabled:None:None");
MODULE_INFO(linuxcnc, "pin:move_enable:bit:0:in:Enable offsets (Enabling requires apply-offset TRUE also):None:None");
MODULE_INFO(linuxcnc, "pin:apply_offsets:bit:0:in:Enable offsets (Enabling requires move-enable TRUE also):None:None");
MODULE_INFO(linuxcnc, "pin:backtrack-enable:bit:0:in:Enable backtrack on auto-return:1:None");
MODULE_INFO(linuxcnc, "pin:epsilon:float:0:in:When enabling pins are deactivated, return to un-offsetted position within epsilon units.  Warning: values that are too small in value may cause overshoot,  A minimum value of 0.0001 is \\fBsilently enforced\\fR:0.0005:None");
MODULE_INFO(linuxcnc, "pin:waypoint-threshold:float:0:in:Minimum distance (in a single axis) for a new waypoint:0.02:None");
MODULE_INFO(linuxcnc, "pin:waypoint-sample-secs:float:0:in:Minimum sample interval (in seconds) for a new waypoint:0.02:None");
MODULE_INFO(linuxcnc, "pin:warning:bit:0:out:Set TRUE if apply-offsets is deasserted while offset-applied is TRUE:None:None");
MODULE_INFO(linuxcnc, "pin:offset_applied:bit:0:out:TRUE if one or more offsets are applied:None:None");
MODULE_INFO(linuxcnc, "pin:waypoint-limit:bit:0:out:Indicates waypoint limit reached (motion ceases), an enabling pin must be deasserted to initiate return to original position:0:None");
MODULE_INFO(linuxcnc, "pin:waypoint-ct:s32:0:out:Waypoint count (for debugging):None:None");
MODULE_INFO(linuxcnc, "pin:waypoint-percent-used:s32:0:out:Percent of available waypoints used:None:None");
MODULE_INFO(linuxcnc, "pin:offset-in-#:float:(9, 'personality'):in:Joint offset input value:None:None");
MODULE_INFO(linuxcnc, "pin:pos-#:float:(9, 'personality'):in:Joint position (typ: axis.0.motor-pos-cmd):None:None");
MODULE_INFO(linuxcnc, "pin:fb-#:float:(9, 'personality'):in:Joint feedback (typ from encoder and input to pid controller (pid.feedback)):None:None");
MODULE_INFO(linuxcnc, "pin:offset-current-#:float:(9, 'personality'):out:Joint offset current value:None:None");
MODULE_INFO(linuxcnc, "pin:pos-plusoffset-#:float:(9, 'personality'):out:Computed joint position plus offset (typically connect to pid command input):None:None");
MODULE_INFO(linuxcnc, "pin:fb-minusoffset-#:float:(9, 'personality'):out:Computed Joint feedback minus offset (typically connected to axis.0.motor-pos-fb:None:None");
MODULE_INFO(linuxcnc, "pin:offset-vel-#:float:(9, 'personality'):in:Joint offset velocity limit:10:None");
MODULE_INFO(linuxcnc, "pin:offset-accel-#:float:(9, 'personality'):in:Joint offset acceleration limit:100:None");
MODULE_INFO(linuxcnc, "pin:offset-min-#:float:(9, 'personality'):in:Minimum limit for applied joint offset (typ negative):-1e20:None");
MODULE_INFO(linuxcnc, "pin:offset-max-#:float:(9, 'personality'):in:Maximum limit for applied offset (typ positive):1e20:None");
MODULE_INFO(linuxcnc, "pin:dbg_waypoint_limit_test:bit:0:in:Debug input to test with limited number of waypoints:None:None");
MODULE_INFO(linuxcnc, "pin:dbg_state:s32:0:out:Debug output for current state of state machine:None:None");
MODULE_INFO(linuxcnc, "funct:read_inputs:1:Read all inputs");
MODULE_INFO(linuxcnc, "funct:write_outputs:1:Write computed offset outputs\n(offset-current-M, pos-plusoffset-M, fb-minusoffset-M).\nAll other outputs are updated by read-inputs()");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    int _personality;
    hal_bit_t *power_on;
    hal_bit_t *move_enable;
    hal_bit_t *apply_offsets;
    hal_bit_t *backtrack_enable;
    hal_float_t *epsilon;
    hal_float_t *waypoint_threshold;
    hal_float_t *waypoint_sample_secs;
    hal_bit_t *warning;
    hal_bit_t *offset_applied;
    hal_bit_t *waypoint_limit;
    hal_s32_t *waypoint_ct;
    hal_s32_t *waypoint_percent_used;
    hal_float_t *offset_in[9];
    hal_float_t *pos[9];
    hal_float_t *fb[9];
    hal_float_t *offset_current[9];
    hal_float_t *pos_plusoffset[9];
    hal_float_t *fb_minusoffset[9];
    hal_float_t *offset_vel[9];
    hal_float_t *offset_accel[9];
    hal_float_t *offset_min[9];
    hal_float_t *offset_max[9];
    hal_bit_t *dbg_waypoint_limit_test;
    hal_s32_t *dbg_state;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void read_inputs(struct __comp_state *__comp_inst, long period);
static void write_outputs(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg, long personality) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_personality = personality;
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    personality = inst->_personality;
    r = hal_pin_bit_newf(HAL_IN, &(inst->power_on), comp_id,
        "%s.power-on", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->move_enable), comp_id,
        "%s.move-enable", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->apply_offsets), comp_id,
        "%s.apply-offsets", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->backtrack_enable), comp_id,
        "%s.backtrack-enable", prefix);
    if(r != 0) return r;
    *(inst->backtrack_enable) = 1;
    r = hal_pin_float_newf(HAL_IN, &(inst->epsilon), comp_id,
        "%s.epsilon", prefix);
    if(r != 0) return r;
    *(inst->epsilon) = 0.0005;
    r = hal_pin_float_newf(HAL_IN, &(inst->waypoint_threshold), comp_id,
        "%s.waypoint-threshold", prefix);
    if(r != 0) return r;
    *(inst->waypoint_threshold) = 0.02;
    r = hal_pin_float_newf(HAL_IN, &(inst->waypoint_sample_secs), comp_id,
        "%s.waypoint-sample-secs", prefix);
    if(r != 0) return r;
    *(inst->waypoint_sample_secs) = 0.02;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->warning), comp_id,
        "%s.warning", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->offset_applied), comp_id,
        "%s.offset-applied", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->waypoint_limit), comp_id,
        "%s.waypoint-limit", prefix);
    if(r != 0) return r;
    *(inst->waypoint_limit) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->waypoint_ct), comp_id,
        "%s.waypoint-ct", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->waypoint_percent_used), comp_id,
        "%s.waypoint-percent-used", prefix);
    if(r != 0) return r;
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->offset_in[j]), comp_id,
            "%s.offset-in-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->pos[j]), comp_id,
            "%s.pos-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->fb[j]), comp_id,
            "%s.fb-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->offset_current[j]), comp_id,
            "%s.offset-current-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->pos_plusoffset[j]), comp_id,
            "%s.pos-plusoffset-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->fb_minusoffset[j]), comp_id,
            "%s.fb-minusoffset-%01d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->offset_vel[j]), comp_id,
            "%s.offset-vel-%01d", prefix, j);
        if(r != 0) return r;
    *(inst->offset_vel[j]) = 10;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->offset_accel[j]), comp_id,
            "%s.offset-accel-%01d", prefix, j);
        if(r != 0) return r;
    *(inst->offset_accel[j]) = 100;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->offset_min[j]), comp_id,
            "%s.offset-min-%01d", prefix, j);
        if(r != 0) return r;
    *(inst->offset_min[j]) = -1e20;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->offset_max[j]), comp_id,
            "%s.offset-max-%01d", prefix, j);
        if(r != 0) return r;
    *(inst->offset_max[j]) = 1e20;
    }
    r = hal_pin_bit_newf(HAL_IN, &(inst->dbg_waypoint_limit_test), comp_id,
        "%s.dbg-waypoint-limit-test", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->dbg_state), comp_id,
        "%s.dbg-state", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.read-inputs", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))read_inputs, inst, 1, 0, comp_id);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.write-outputs", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))write_outputs, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
char *names[16] = {0,};
RTAPI_MP_INT(count, "number of moveoff");
RTAPI_MP_ARRAY_STRING(names, 16, "names of moveoff");
static int personality[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_INT(personality, 16, "personality of each moveoff");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("moveoff");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "moveoff.%d", i);
            r = export(buf, i, personality[i%16]);
            if(r != 0) break;
       }
    } else {
        int max_names = sizeof(names)/sizeof(names[0]);
        for(i=0; (i < max_names) && names[i]; i++) {
            if (strlen(names[i]) < 1) {
                rtapi_print_msg(RTAPI_MSG_ERR, "names[%d] is invalid (empty string)\n", i);
                r = -EINVAL;
                break;
            }
            r = export(names[i], i, personality[i%16]);
            if(r != 0) break;
       }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef power_on
#define power_on (0+*__comp_inst->power_on)
#undef move_enable
#define move_enable (0+*__comp_inst->move_enable)
#undef apply_offsets
#define apply_offsets (0+*__comp_inst->apply_offsets)
#undef backtrack_enable
#define backtrack_enable (0+*__comp_inst->backtrack_enable)
#undef epsilon
#define epsilon (0+*__comp_inst->epsilon)
#undef waypoint_threshold
#define waypoint_threshold (0+*__comp_inst->waypoint_threshold)
#undef waypoint_sample_secs
#define waypoint_sample_secs (0+*__comp_inst->waypoint_sample_secs)
#undef warning
#define warning (*__comp_inst->warning)
#undef offset_applied
#define offset_applied (*__comp_inst->offset_applied)
#undef waypoint_limit
#define waypoint_limit (*__comp_inst->waypoint_limit)
#undef waypoint_ct
#define waypoint_ct (*__comp_inst->waypoint_ct)
#undef waypoint_percent_used
#define waypoint_percent_used (*__comp_inst->waypoint_percent_used)
#undef offset_in
#define offset_in(i) (0+*(__comp_inst->offset_in[i]))
#undef pos
#define pos(i) (0+*(__comp_inst->pos[i]))
#undef fb
#define fb(i) (0+*(__comp_inst->fb[i]))
#undef offset_current
#define offset_current(i) (*(__comp_inst->offset_current[i]))
#undef pos_plusoffset
#define pos_plusoffset(i) (*(__comp_inst->pos_plusoffset[i]))
#undef fb_minusoffset
#define fb_minusoffset(i) (*(__comp_inst->fb_minusoffset[i]))
#undef offset_vel
#define offset_vel(i) (0+*(__comp_inst->offset_vel[i]))
#undef offset_accel
#define offset_accel(i) (0+*(__comp_inst->offset_accel[i]))
#undef offset_min
#define offset_min(i) (0+*(__comp_inst->offset_min[i]))
#undef offset_max
#define offset_max(i) (0+*(__comp_inst->offset_max[i]))
#undef dbg_waypoint_limit_test
#define dbg_waypoint_limit_test (0+*__comp_inst->dbg_waypoint_limit_test)
#undef dbg_state
#define dbg_state (*__comp_inst->dbg_state)
#undef personality
#define personality (__comp_inst->_personality)


#line 160 "hal/components/moveoff.comp"

#include "rtapi_math.h"
#define NCHANNELS         9
#define NWAYPOINTS     1000
#define TST_NWAYPOINTS   50
#define MIN_EPSILON       0.0001

typedef enum {
  IDLE,
  MOVE_AWAY,
  MOVE_BACK,
} the_state;

typedef struct {
int state[NCHANNELS];
    hal_float_t old_in[NCHANNELS];
    hal_float_t old_out[NCHANNELS];
    hal_float_t old_v[NCHANNELS];
    hal_float_t old_limited_in[NCHANNELS];
} old_values_t;

struct lim3_input {
    hal_float_t  minlimit;
    hal_float_t  maxlimit;
    hal_float_t  maxvlimit;
    hal_float_t  maxalimit;
    hal_float_t  in;
    hal_float_t  old_in;
    hal_float_t  old_out;
    hal_float_t  old_v;
};

static void reset_old(int nchan, old_values_t* d) {
    int i;
    for (i = 0;i < nchan; i++) {
        d->old_in[i]         = 0;
        d->old_out[i]        = 0;
        d->old_v[i]          = 0;
        d->old_limited_in[i] = 0;
    }
}

static int offset_removed(int nchan, old_values_t d, hal_float_t eps) {
    int removed = 1;
    int i;
    for (i = 0 ; i < nchan ; i++) {
        if (fabs(d.old_out[i]) > eps) {
            removed = 0;
            break;
        }
    }
    return removed;
}

static int at_waypoint(int nchan,
                       hal_float_t g[],
                       hal_float_t p[],hal_float_t eps) {
    int within_eps = 1;
    int i;

    for (i = 0 ; i < nchan ; i++) {
        if ( fabs(p[i] - g[i]) > eps ) {
            within_eps = 0;
            break;
        }
    }
    return within_eps;
}

static long theperiod;
static void lim3(struct lim3_input input,
                 hal_float_t* old_in,
                 hal_float_t* limited_out,
                 hal_float_t* old_v
                ) {
    /* following code is adapted from limit3.comp */
    hal_float_t dt = theperiod * 1e-9;
    hal_float_t in_v, min_v, max_v, avg_v;
    hal_float_t min_out,max_out;
    hal_float_t ramp_a, match_time, est_in, est_out;
    hal_float_t err, dv, dp;
    hal_float_t limited_in;

    /* apply first order limit */
    limited_in = input.in;
    if (input.in < input.minlimit) {
        limited_in = input.minlimit;
    }
    if (input.in > input.maxlimit) {
         limited_in = input.maxlimit;
    }
    *old_in = limited_in;

    /* calculate input derivative */
    in_v = (limited_in - input.old_in) / dt;

    /* determine v and out that can be reached in one period */
    min_v = input.old_v - input.maxalimit * dt;
    if (min_v < -input.maxvlimit) {
        min_v = -input.maxvlimit;
    }
    max_v = input.old_v + input.maxalimit * dt;
    if (max_v > input.maxvlimit) {
        max_v = input.maxvlimit;
    }

    min_out = input.old_out + min_v * dt;
    max_out = input.old_out + max_v * dt;
    if (   ( limited_in >= min_out ) && ( limited_in <= max_out )
        && ( in_v >= min_v ) && ( in_v <= max_v ) ) {
        /* we can follow the command without hitting a limit */
        *limited_out = limited_in;
        *old_v = ( *limited_out - input.old_out ) / dt;
    } else {
        /* can't follow commanded path while obeying limits */
        /* determine which way we need to ramp to match v */
        if ( in_v > input.old_v ) {
            ramp_a = input.maxalimit;
        } else {
            ramp_a = -input.maxalimit;
        }
        /* determine how long the match would take */
        match_time = ( in_v - input.old_v ) / ramp_a;
        /* where we will be at the end of the match */

        avg_v = ( in_v + input.old_v + ramp_a * dt ) * 0.5;
        est_out = input.old_out + avg_v * match_time;
        /* calculate the expected command position at that time */
        est_in = input.old_in + in_v * match_time;
        /* calculate position error at that time */
        err = est_out - est_in;
        /* calculate change in final position if we ramp in the
        opposite direction for one period */
        dv = -2.0 * ramp_a * dt;
        dp = dv * match_time;
        /* decide what to do */
        if ( fabs(err + dp*2.0) < fabs(err) ) {
            ramp_a = -ramp_a;
        }
        if ( ramp_a < 0.0 ) {
            *limited_out = min_out;
            *old_v = min_v;
        } else {
            *limited_out = max_out;
            *old_v = max_v;
        }
    }
    return;
}

static the_state    state = IDLE;
static int          next_waypoint_index;
static rtapi_s64    last_waypoint_time;
static rtapi_s64    now;
static hal_float_t  time_since_last_sample;
static hal_float_t  move_threshold;
static hal_float_t  min_sample_interval;
static bool         backtrack;
static bool         gave_msg;
static int          max_waypoints = NWAYPOINTS;
static struct       lim3_input input;
static hal_float_t  goal[NCHANNELS];
static hal_float_t  waypoints[NCHANNELS][NWAYPOINTS];
static old_values_t data;

static hal_float_t  eps_in_use;
static bool         move_in_progress = 0;
static the_state    next_state;

//compile time setting:
static const bool   allow_backtrack_enable_change = 1;
// 1 ==> backtrack-enable can be changed while enabled
//       waypoints are always accumulated and waypoint_limit enforced
// 0 ==> backtrack-enable is sampled only while IDLE
//       if backtrack-enable == 0, no waypoints and no waypoint_limit
//       (e.g., unlimited no. of offset samples)

FUNCTION(read_inputs) {
    hal_float_t last,delta;
    int r;
    bool all_enables  = power_on && move_enable && apply_offsets;

    if (allow_backtrack_enable_change) {
      backtrack = backtrack_enable;
      // change at any time (controls auto-return)
    }

    theperiod = period;
    now = rtapi_get_time();
    if (state == IDLE) {
        backtrack = backtrack_enable; // ref: allow_backtrack_enable_change
        // allow changes only when IDLE for these inputs:
        move_threshold = waypoint_threshold;
        min_sample_interval = waypoint_sample_secs;
        eps_in_use = epsilon;
        if (eps_in_use < MIN_EPSILON) { eps_in_use = MIN_EPSILON; }


        if (dbg_waypoint_limit_test) {
            max_waypoints = TST_NWAYPOINTS; // tiny limit for testing
        } else {
            max_waypoints = NWAYPOINTS;
        }
    }

    if (backtrack || allow_backtrack_enable_change) {
        int r;
        bool sufficient_movement_for_new_waypoint = 0;

        time_since_last_sample = (hal_float_t)(now - last_waypoint_time)/1e9;
        switch (state) {
            case IDLE:
                  next_waypoint_index = 0;
                  break;
            case MOVE_AWAY:
                //note: gui must handle waypoint_limit -- here we just stop
                if (waypoint_limit) break; // no more room for waypoints

                if (time_since_last_sample < min_sample_interval) break;
                for (r=0; r < personality; r++) {
                    last  = waypoints[r][next_waypoint_index - 1];
                    delta = fabs(offset_current(r) - last);
                    if (delta > move_threshold) {
                        sufficient_movement_for_new_waypoint = 1;
                        break; //for loop
                    }
                }
                if (!sufficient_movement_for_new_waypoint) break;
                for (r=0; r < personality; r++) {
                    waypoints[r][next_waypoint_index] = offset_current(r);
                }
                last_waypoint_time = now;
                next_waypoint_index++;
                if (next_waypoint_index > max_waypoints - 1) {
                    waypoint_limit = 1;
                } else {
                    waypoint_limit = 0;
                }
                break;
            case MOVE_BACK: break;
       }
    } //end save waypoints

    //{begin state control
    switch (state) {
      case IDLE:
            last_waypoint_time = now;
            if ( all_enables ) {
                next_state = MOVE_AWAY;
                move_in_progress = 1;
                for (r = 0; r < personality; r++) {
                    goal[r] = offset_in(r);
                }
            }
            break;
      case MOVE_AWAY:
            move_in_progress = 1;
            if ( all_enables ) {
               // allow offset movements
               for (r = 0; r < personality; r++) {
                    goal[r] = offset_in(r);
               }
               break;
            }
            // one (or more) enablers is gone
            next_state = MOVE_BACK;
            if (!power_on) {
                reset_old(personality, &data);
                move_in_progress = 0;
                offset_applied = 0;
                next_state = IDLE;
                break;
            }
            for (r = 0; r < personality; r++) {
                goal[r] = 0; // default (eg not waypoint backtrack)
            }
            if (backtrack) {
                if ( next_waypoint_index > 0 ) {
                    for (r = 0; r < personality; r++) {
                        goal[r] = waypoints[r][next_waypoint_index-1];
                    }
                    waypoint_limit = 0;
                    next_waypoint_index--;
                }
            }
            break;

      case  MOVE_BACK:
            if (!power_on) {
                reset_old(personality, &data);
                move_in_progress = 0;
                offset_applied = 0;
                next_state = IDLE;
                break;
            }
            move_in_progress = 1;
            if (backtrack) {
                if ( next_waypoint_index > 0 ) {
                    hal_float_t pcur[NCHANNELS];
                    for (r=0; r < personality; r++) {
                        pcur[r] = offset_current(r);
                    }
                    if (at_waypoint(personality, goal, pcur, eps_in_use)) {
                        for (r = 0; r < personality; r++) {
                            goal[r] = waypoints[r][next_waypoint_index];
                        }
                        next_waypoint_index--;
                    }
                } else {
                    for (r = 0; r < personality; r++) {
                        goal[r] = 0; //final goal
                    }
                }
            }

            if (!offset_applied) {
                // offsets gone, return to IDLE
                next_state = IDLE;
                move_in_progress = 0;
                reset_old(personality, &data);
            }
            break;
    }

    if (   !apply_offsets
        &&  offset_applied
        ) {
        warning = 1;
        if (!gave_msg) {
            // apply_offsets deasserted while offset_applied
            // for example:
            //   1) program stopped with offsets applied
            //   2) (no *.resume-inhibit pin) or (-no_resume_inhibit option)
            //      and program resumed with offsets applied
            for (r = 0; r < personality; r++) {
                rtapi_print_msg(RTAPI_MSG_ERR,
                           "Index: %i, offset=%f",
                           r, data.old_out[r]);
            }
            rtapi_print_msg(RTAPI_MSG_ERR,
            "apply_offsets deasserted before offsets removed "
            "moveoff.comp: WARNING"
            );
            gave_msg = 1;
        }
    } else {
        gave_msg = 0;
        warning = 0;
    }
    //}end state control
} //read_inputs

FUNCTION(write_outputs) {
    int r;
    // move with limits on postion, velocity, acceleration
    for (r = 0; r < personality; r++) {
        if (move_in_progress) {
            input.in = goal[r];
            input.minlimit   = offset_min(r);
            input.maxlimit   = offset_max(r);
            input.maxvlimit  = offset_vel(r);
            input.maxalimit  = offset_accel(r);
            input.old_in     = data.old_in[r];
            input.old_out    = data.old_out[r];
            input.old_v      = data.old_v[r];

            if ( waypoint_limit && (state == MOVE_AWAY) ) {
                // no movement in MOVE_AWAY (require: remove enable)
            } else {
                hal_float_t last_old = data.old_out[r];
                lim3(input,
                     &data.old_in[r],
                     &data.old_out[r],
                     &data.old_v[r]
                     );
                offset_current(r) = data.old_out[r];
                fb_minusoffset(r) = fb(r)  - offset_current(r)
                                  - (last_old - data.old_out[r]);
                pos_plusoffset(r) = pos(r) + offset_current(r);
            }
        } else {
            pos_plusoffset(r) = pos(r);
            offset_current(r) = 0;
            fb_minusoffset(r) = fb(r);
        }
    }

    offset_applied = ! offset_removed(personality, data, eps_in_use);
    if ( !offset_applied ) {
        // reset backtrack
        next_waypoint_index = 0;
        waypoint_limit = 0;
    }

    waypoint_ct = next_waypoint_index;
    waypoint_percent_used = 100*next_waypoint_index/max_waypoints;

    dbg_state = state;
    state = next_state;
} //write_outputs

EXTRA_SETUP() {
    if (personality == 0) personality = 3;
    return 0;
}

static int __comp_get_data_size(void) { return 0; }
